// C Source File
// Created 4/28/02; 5:47:35 PM

// Available Patches
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH
#define USE_LONGDIV_PATCH
#define OPTIMIZE_ROM_CALLS    // Use Speed Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

//FOR THE TI92
#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define UP_KEY 32
#define LEFT_KEY 16
#define DOWN_KEY 128
#define RIGHT_KEY 64
#define SECOND_KEY 1
#define SHIFT_KEY 4
#define DIAMOND_KEY 2
#define ALPHA_KEY 8

#define ESC_ROW 0xffbf
#define ESC_KEY 1

#define PLUS_ROW 0xfeff
#define PLUS_KEY 16

#define MINUS_ROW 0xfdff
#define MINUS_KEY 1

#define TIMES_ROW 0xff7f
#define TIMES_KEY 128

#define DIVIDE_ROW 0xffdf
#define DIVIDE_KEY 1



#define APPS_ROW 0xff7f
#define APPS_KEY 64

#define HOME_ROW 0xffdf
#define HOME_KEY 64

#define STO_ROW 0xfeff
#define STO_KEY 2

#define F1_ROW 0xffbf
#define F2_ROW 0xffef
#define F3_ROW 0xfffb
#define F4_ROW 0xfdff
#define F5_ROW 0xff7f
#define FX_KEY 1


int _ti92plus;                // Produce .9XZ File

char _comment[]="CANYON RACER V1.0 by MurBeck";

// Main Function

int get_key(void)
{
  void *kbq = kbd_queue();
  int key;
   if (OSTimerExpired(APD_TIMER))
   {
   off();
   OSTimerRestart(APD_TIMER);
   }
   if (!OSdequeue(&key, kbq)) OSTimerRestart (APD_TIMER);
  return key & 0xf7ff;  // mask out 0x800 (repeat flag)
}

void scroll_left(void)      // Ugly, but very efficiently - This is C!
{
  register long ptr;
  register int i;
  for(ptr=0x4c00+10;ptr<=0x57b8+800;ptr+=10)
    for(i=0;i<=4;i++,ptr+=4) poke_l(ptr,(peek_l(ptr)<<1)+(speek_l(ptr+4)<0));
}

void _box(int a,int b,int c,int d, int f)  //Draws a box in the given plane
{
  DrawLine (a,b,c,b,f);
  DrawLine (a,b,a,d,f);
  DrawLine (c,b,c,d,f);
  DrawLine (a,d,c,d,f);
}

void fill_it(int a, int b, int c, int d)
{
  int e;
	for (e=b; e<d+1; e++)
	 DrawLine (a,e,c,e,A_XOR);
}

int get_pixel(int x,int y)  // Faster replacement for GetPix from TIOS
{
  return !!(peek(0x4c00+30*y+(x>>3))&(1<<(~x&7)));
}

char *IntToStr (unsigned long tm)
{
	static char result [] = "         \0";
	char *ptr = result + 10;
	while (tm)
	{
		*ptr-- = tm % 10 + '0';
		tm/=10;
	}
	return ptr;
}


int put_sprite(int x,int y,int sprite[])
{
  register long addr=0x4c00+30*y+((x>>3)&0xfffe),colision=0,data;
  register int i,cnt=16-(x&15);
  for(i=0;i<=7;i++,addr+=30)
    colision|=((data=(long)sprite[i]<<cnt)&peek_l(addr)),*(long*)addr^=data;
  return !colision;
}

void _main(void)
{
	// Place your code here.
  static int plane[]={0x2000,0x7e7c,0x63c2,0x6c1b,0x231b,0x6c1b,0x63c2,0x7e7c,0x2000};
  int lvl=1,a=1,upb=0,key=0,up=0,open=50,mdl=50,d=0,c=0;
	unsigned long int b=0,score=0;
	unsigned int hp=200;
	static unsigned long hscore=20;
	char txt[50];
Beg:
	ClrScr();
	_box(10,10,230,118,A_NORMAL);
	_box(11,11,229,117,A_NORMAL);
Chs:
	key = 0;
	FontSetSys(F_6x8);
  DrawStr (160,60,IntToStr(hscore),A_REPLACE);
	FontSetSys (F_4x6);
	DrawStr (150,109,"V1.0 by MurBeck",A_REPLACE);
	FontSetSys(F_8x10);
	DrawStr (14,14,"CANYON  R A C E R",A_NORMAL);
	DrawStr (137,45,"High Score:",A_NORMAL);
	DrawStr (24,40,"1  Play",A_NORMAL);
	sprintf (txt,"%d",lvl);
	DrawStr (95,60,txt,A_REPLACE);
	DrawStr (24,60,"2  Speed",A_NORMAL);
	DrawStr (24,80,"3  Exit",A_NORMAL);
	fill_it (12,18+(a*20),120,32+(20*a));
	while (key==0)
	{
		key = ngetchx();
	}
	fill_it (12,18+(a*20),120,32+(20*a));
	if (key == 13 && a==1) goto Play;
	if (key==338 && a>1)a--;
	if (key==344 && a<3)a++;
	if (key == 13 && a==2)lvl++;
	if (key == 13 && a==2 && lvl==6)lvl=1;
	if (key == 264) goto End;
	if (key == 13 && a==3) goto End;
  goto Chs;
Play:
  OSSetSR(0x0400);
	ClrScr();
	_box(4,4,74,124,A_NORMAL);
	_box(5,5,73,123,A_NORMAL);
	DrawStr (10,10,"Armor:",A_NORMAL);
	DrawStr (10,40,"Time:",A_NORMAL);
	DrawStr (10,70,"Score:",A_NORMAL);
	FontSetSys (F_6x8);
	score=0;
	up=60;
	upb=up;
	hp=200;
  open=37;
  c=0;
	put_sprite(79,up=60,plane);
  OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER,70*20);
while(hp>0)
{
	if(OSTimerCurVal(USER_TIMER)<=(10*20))
	{
		c++;
		hp=hp+15;
		if(hp>200)hp=200;
		OSTimerRestart(USER_TIMER);
	}
	score=(60*c)+(70-(unsigned int)OSTimerCurVal(USER_TIMER)/20);
	sprintf (txt, "%3d", hp);
	DrawStr (10,24,txt,A_REPLACE);
	sprintf (txt,"%3d:%2d",c,70-(unsigned int)(OSTimerCurVal(USER_TIMER)/20));
	strcat (txt," ");
	DrawStr (10,54,txt,A_REPLACE);
	printf_xy (10,84,"%04lu ",score);
	put_sprite(79,upb,plane);
	if(!put_sprite(80,up,plane))hp--;
	upb=up;
	for(b=0;b<200*(5-lvl);b++);
	if (_rowread(F4_ROW)&ALPHA_KEY) goto End1;
	key=_rowread(ARROWS_ROW);
	if (key&UP_KEY && up>1)up--;
	if (key&DOWN_KEY && up<127)up++;
	mdl=mdl+random(11)-5;
	open=open+random(5)-2;
	if(open<34)open=34;
	if(open>50)open=50;
	if (mdl<30)mdl=40;
	if (mdl>92)mdl=92;
	DrawLine (239,0,239,127,A_NORMAL);
	DrawLine (239,mdl-(open/2),239,mdl+(open/2),A_REVERSE);
  scroll_left();
}
End1:
 if(score>hscore){
  FontSetSys(F_8x10);
  DrawStr(60,45,"!!NEW HIGH SCORE!!",A_REPLACE);
  hscore=score;
 }
 ngetchx();
 goto Beg;
End:
 FontSetSys (F_6x8);
}
